package formFaces.excepcio;

import java.lang.Exception;
/**
 * 
 * @author Jaume
 *
 * Excepci amb gravetat. gravetats possibles
 * 			5		Errors definici formularis
 * 			4		Errors de procs
 * 			3		Errors de validaci
 * 			2		Warning avs
 * 			1		Informatius
 */
public class FormFacesExcepcio extends Exception implements Comparable<FormFacesExcepcio>{

	private int gravetat;
	
	public FormFacesExcepcio(){
		super();
		gravetat = 0;
	}
	
	public FormFacesExcepcio(int gravetat){
		super();
		this.gravetat = gravetat;
	}
	public FormFacesExcepcio(String missatge, int gravetat){
		super(missatge);
		this.gravetat = gravetat;
	}

	public void setGravetat(int gravetat) {
		this.gravetat = gravetat;
	}
	
	public int getGravetat(){
		return gravetat;
	}

	public int compareTo(FormFacesExcepcio f){
		if (gravetat==f.getGravetat()){
			return this.getMessage().compareTo(f.getMessage());
		} else {
			return gravetat - f.getGravetat();
		}
	}
	
}
