package formFaces.tags;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspWriter;
import javax.servlet.ServletRequest;

import java.io.IOException;

import java.util.Iterator;


import formFaces.excepcio.*;

public class ListErrorsTag extends TagSupport {
	
		private int gravetatMinima;
	
		public int doStartTag() {
			ServletRequest request = pageContext.getRequest();
			Excepcions ex = (Excepcions)request.getAttribute("excepcions");
			if (ex != null) {
				try {
					JspWriter out = pageContext.getOut();
					out.print("<table><TR>");
					out.print("<TD valign=\"center\"><font color=\"red\">Errors</font></TD>");
					out.print("</TR>");
					if (!ex.teExcepcions(gravetatMinima)){
						out.print("<TR><TD colspan=\"2\" align=\"center\">No hi ha cap Error</TD></TR>");
					} else {
						for (Iterator<FormFacesExcepcio> it=ex.getItExcepcions(gravetatMinima); it.hasNext();){
							out.print("<TR>");
							FormFacesExcepcio cl = it.next();
							out.print("<TD>"+cl.getMessage()+"</TD>");
							out.print("</TR>");
						}
					}
					out.print("</table>");
				} catch(IOException ioe) {
					System.out.println("Error construint ListErrorsTag: " + ioe);
				}
				return(EVAL_BODY_INCLUDE);
			} else {
				System.out.println("Error construint ListErrorsTag JspForm no existeix a request");
				return(SKIP_BODY);
			}
		}
		
		public int getGravetatMinima() {
			return gravetatMinima;
		}

		public void setGravetatMinima(int gravetatMinima) {
			this.gravetatMinima = gravetatMinima;
		}

		public int doEndTag() {
			return(EVAL_PAGE); // Continue with rest of JSP page
		}
		
}
