package formFaces.tags;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspWriter;
import javax.servlet.ServletRequest;

import java.io.IOException;

import formFaces.action.JspForm;

public class ParametreInputTag extends TagSupport {
	
	private String nomParametre;
	private String tipusInput;
	private String nomInput;
	
		public int doStartTag() {
			ServletRequest request = pageContext.getRequest();
			JspForm jf = (JspForm)request.getAttribute("JspForm");
			if (jf != null) {
				try {
					if (nomInput == null){nomInput = nomParametre;}
					if (tipusInput == null){tipusInput = "text";}
					JspWriter out = pageContext.getOut();
					out.print("<input type=\""+tipusInput+"\" name=\""+nomInput+"\" value=\""+jf.getValor(nomParametre)+"\">");
				} catch(IOException ioe) {
					System.out.println("Error cercant el valor del parametre "+nomParametre+": " + ioe);
				}
				return(EVAL_BODY_INCLUDE);
			} else {
				System.out.println("Error construint ParametreInputTag JspForm no existeix a request");
				return(SKIP_BODY);
			}
		}
		
		public void setNomParametre(String nom) {
			this.nomParametre = nom;
		}		


		public void setNomInput(String nom) {
			this.nomInput = nom;
		}		


		public void setTipusInput(String tipus) {
			this.tipusInput = tipus;
		}		


		public int doEndTag() {
			return(EVAL_PAGE); // Continue with rest of JSP page
		}
		
}
