package formFaces.tags;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspWriter;
import javax.servlet.ServletRequest;

import java.io.IOException;

import formFaces.action.JspForm;

public class ParametreTag extends TagSupport {
	
	private String nomParametre;
	
		public int doStartTag() {
			ServletRequest request = pageContext.getRequest();
			JspForm jf = (JspForm)request.getAttribute("JspForm");
			if (jf != null) {
				try {
					JspWriter out = pageContext.getOut();
					out.print(jf.getValor(nomParametre));
				} catch(IOException ioe) {
					System.out.println("Error cercant el valor del parametre "+nomParametre+": " + ioe);
				}
				return(EVAL_BODY_INCLUDE);
			} else {
				System.out.println("Error construint ParametreTag JspForm no existeix a request");
				return(SKIP_BODY);
			}
		}
		
		public void setNomParametre(String nom) {
			this.nomParametre = nom;
		}		



		public int doEndTag() {
			return(EVAL_PAGE); // Continue with rest of JSP page
		}
		
}
