package formFaces.tags;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspWriter;
import javax.servlet.ServletRequest;

import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.StringTokenizer;


import formFaces.action.JspForm;
import formFaces.action.Classe;

public class TableListTag extends TagSupport {
	
	private String nomLlista;
	private String border;
	private List<String> camps;
	private String descFuncio1;
	private String funcio1;
	private List<String> campsFuncio1;
	private String descFuncio2;
	private String funcio2;
	private List<String> campsFuncio2;
	private String descFuncio3;
	private String funcio3;
	private List<String> campsFuncio3;
	
		public int doStartTag() {
			if (camps==null){camps=new ArrayList<String>();}
			if (campsFuncio1==null){campsFuncio1=new ArrayList<String>();}
			if (campsFuncio2==null){campsFuncio2=new ArrayList<String>();}
			if (campsFuncio3==null){campsFuncio3=new ArrayList<String>();}
			ServletRequest request = pageContext.getRequest();
			JspForm jf = (JspForm)request.getAttribute("JspForm");
			if (jf != null) {
				List<Classe> llista = jf.getLlista(nomLlista);
				if (llista != null) {
					try {
						String underline = "";
						JspWriter out = pageContext.getOut();
						if (border == null){
							out.print("<table><TR>");
						} else {
							out.print("<table border=" + border +"><TR>");
						}
						for (Iterator<String> it = camps.iterator(); it.hasNext();){
							String v = it.next();
							underline = underline + "==========";
							out.print("<TD>&nbsp;&nbsp;"+v+"</TD>");
						}
						int numCamps = camps.size();
						if (descFuncio1!=null){
							out.print("<TD>&nbsp;</TD>");
							numCamps = numCamps+1;
							underline = underline + "==========";
						}
						if (descFuncio2!=null){
							out.print("<TD>&nbsp;</TD>");
							numCamps = numCamps+1;
							underline = underline + "==========";
						}
						if (descFuncio3!=null){
							out.print("<TD>&nbsp;</TD>");
							numCamps = numCamps+1;
							underline = underline + "==========";
						}
						out.print("</TR>");
						out.print("<TR><TD colspan=\""+numCamps+"\">"+underline+"</TD></TR>");
						if (llista.isEmpty()){
							out.print("<TR><TD colspan=\""+numCamps+"\" align=\"center\">No hi ha cap registre</TD></TR>");
						} else {
							for (Iterator<Classe> it=llista.iterator(); it.hasNext();){
								out.print("<TR>");
								Classe cl = it.next();
								for (Iterator<String> itc = camps.iterator(); itc.hasNext();){
									String v = cl.getValor(itc.next());
									out.print("<TD>"+v+"</TD>");
								}
								if (descFuncio1!=null){
									out.print("<TD><A HREF=\"javascript:"+funcio1+"('");
									boolean primer = true;
									for (Iterator<String> itf = campsFuncio1.iterator(); itf.hasNext();){
										if (primer){
											primer = false;
										} else {
											out.print("', '");
										}
										String v = cl.getValor(itf.next());
										out.print(v);
									}
									out.print("')\">&nbsp;&nbsp;"+descFuncio1+"</A></TD>");
								}
								if (descFuncio2!=null){
									out.print("<TD><A HREF=\"javascript:"+funcio2+"('");
									boolean primer = true;
									for (Iterator<String> itf = campsFuncio2.iterator(); itf.hasNext();){
										if (primer){
											primer = false;
										} else {
											out.print("', '");
										}
										out.print(cl.getValor(itf.next()));
									}
									out.print("')\">&nbsp;&nbsp;"+descFuncio2+"</A></TD>");
								}
								if (descFuncio3!=null){
									out.print("<TD><A HREF=\"javascript:"+funcio3+"('");
									boolean primer = true;
									for (Iterator<String> itf = campsFuncio3.iterator(); itf.hasNext();){
										if (primer){
											primer = false;
										} else {
											out.print("', '");
										}
										out.print(cl.getValor(itf.next()));
									}
									out.print("')\">&nbsp;&nbsp;"+descFuncio3+"</A></TD>");
								}
								out.print("</TR>");
							}
						}
						out.print("</table>");
					} catch(Exception ioe) {
						System.out.println("Error construint TableListTag "+nomLlista+": " + ioe);
					}
					return(EVAL_BODY_INCLUDE);
				} else {
					System.out.println("Error construint TableListTag Llista "+nomLlista+" no existeix a request");
					return(SKIP_BODY);
				}
			} else {
				System.out.println("Error construint TableListTag JspForm no existeix a request");
				return(SKIP_BODY);
			}
		}
		
		public void setNomLlista(String nomLlista) {
			this.nomLlista = nomLlista;
		}		

		public void setBorder(String border) {
			this.border = border;
		}
		
		public void setCamps(String txCamps){
			camps = new ArrayList<String>();
			StringTokenizer st = new StringTokenizer(txCamps, ",");
			while (st.hasMoreElements()){
				camps.add(st.nextToken());
			}
			
		}

		public void setFuncio1(String txFuncio){
			int i = txFuncio.indexOf("=");
			if (i!=-1){
				String nom = txFuncio.substring(0, i);
				int j = txFuncio.indexOf("(", i);
				if (j !=-1){
					String funcio = txFuncio.substring(i+1, j);
					if (txFuncio.endsWith(")")){
						descFuncio1 = nom;
						funcio1 = funcio;
						campsFuncio1 = new ArrayList<String>();
						StringTokenizer st = new StringTokenizer(txFuncio.substring(j+1, txFuncio.length()-1), ",");
						while (st.hasMoreElements()){
							String v = st.nextToken();
							campsFuncio1.add(v);
						}
					}
				}
			}			
		}

		public void setFuncio2(String txFuncio){
			int i = txFuncio.indexOf("=");
			if (i!=-1){
				String nom = txFuncio.substring(0, i);
				int j = txFuncio.indexOf("(", i);
				if (j !=-1){
					String funcio = txFuncio.substring(i, j);
					if (txFuncio.endsWith(")")){
						descFuncio2 = nom;
						funcio2 = funcio;
						campsFuncio2 = new ArrayList<String>();
						StringTokenizer st = new StringTokenizer(txFuncio.substring(j, txFuncio.length()-1), ",");
						while (st.hasMoreElements()){
							campsFuncio2.add(st.nextToken());
						}
					}
				}
			}
			
		}

		public void setFuncio3(String txFuncio){
			int i = txFuncio.indexOf("=");
			if (i!=-1){
				String nom = txFuncio.substring(0, i);
				int j = txFuncio.indexOf("(", i);
				if (j !=-1){
					String funcio = txFuncio.substring(i, j);
					if (txFuncio.endsWith(")")){
						descFuncio3 = nom;
						funcio3 = funcio;
						campsFuncio3 = new ArrayList<String>();
						StringTokenizer st = new StringTokenizer(txFuncio.substring(j, txFuncio.length()-1), ",");
						while (st.hasMoreElements()){
							campsFuncio3.add(st.nextToken());
						}
					}
				}
			}
		}

		public int doEndTag() {
			return(EVAL_PAGE); // Continue with rest of JSP page
		}
		
}
