package formFaces.action;

import java.util.List;
import java.util.ArrayList; 
import java.util.Iterator;

public class JspResolver {
	private String jsp;
	private List<Status> estats;
	
	public JspResolver(String jsp) {
		super();
		this.jsp = jsp;
		estats = new ArrayList<Status>();
	}

	public String getJsp() {
		return jsp;
	}

	public void setJsp(String jsp) {
		this.jsp = jsp;
	}
	
	public Status setEstat(String tipus, String camp){
		Status s = new Status(tipus, camp);
		estats.add(s);
		return s;
	}
	
	public String resolve(ActionForm a){
		boolean correcte = true;
		for (Iterator<Status> it = estats.iterator(); it.hasNext();){
			if(!it.next().valida(a)){
				correcte = false;
			}
		}
		if (correcte){
			return jsp;
		} else {
			return null;
		}
	}

}
