package formFaces.excepcio;

import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Collections;

public class Excepcions {
	private List<FormFacesExcepcio> excepcions;
	
	public Excepcions(){
		excepcions = new ArrayList<FormFacesExcepcio>();
	}
	
	public Excepcions(FormFacesExcepcio e){
		excepcions = new ArrayList<FormFacesExcepcio>();
		excepcions.add(e);
	}
	
	public void nova(FormFacesExcepcio e){
		excepcions.add(e);
	}

	public List<FormFacesExcepcio> getExcepcions() {
		return excepcions;
	}

	public List<FormFacesExcepcio> getExcepcions(int gravetatMinima) {
		List<FormFacesExcepcio> ex = new ArrayList<FormFacesExcepcio>(); 
		for (Iterator<FormFacesExcepcio> it=excepcions.iterator(); it.hasNext();){
			FormFacesExcepcio e = it.next();
			if (e.getGravetat()>=gravetatMinima){
				ex.add(e);
			}
		}
		return ex;
	}

	public void setExcepcions(List<FormFacesExcepcio> excepcions) {
		this.excepcions = excepcions;
	}

	public Iterator<FormFacesExcepcio> getItExcepcions() {
		return excepcions.iterator();
	}

	public Iterator<FormFacesExcepcio> getItExcepcions(int gravetatMinima) {
		List<FormFacesExcepcio> ex = getExcepcions(gravetatMinima); 
		Collections.sort(ex);
		return ex.iterator();
	}	
	
	public boolean teExcepcions(){
		return !excepcions.isEmpty();
	}
	
	public boolean teExcepcions(int gravetatMinima){
		List<FormFacesExcepcio> ex = getExcepcions(gravetatMinima);
		return !ex.isEmpty();
	}
	
	public void clear(){
		excepcions.clear();
	}
	
}
