package formFaces.facade;

import java.io.IOException;
import java.util.Iterator;

import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import formFaces.action.ActionForm;
import formFaces.action.JspForm;
import formFaces.action.Action;
import formFaces.excepcio.*;

public class ApplicationController {
	
	protected String execute(ServletRequest request, ServletResponse response)
			throws ServletException,IOException {
		String nextPage = null;
		String nameAction = request.getParameter("action");
		try {
			ActionForm af = Factory.getReference().getActionForm(nameAction);
			if (af != null){
				af.map(request);
				if (!af.getExcepcions().teExcepcions(3)){
					Action a = Factory.getReference().getAction(nameAction);
					if (a == null){
						af.novaExcepcio(new FormFacesExcepcio("Acci "+nameAction+" no creada", 5));
						printErrors(af);
					} else {
						try {
							a.execute(af);	
							try {
								String pageNext = af.resolJsp();
								if (pageNext!=null){
									JspForm jf = Factory.getReference().getJspForm(pageNext);
									if (jf != null) {
										jf.map(af);
										if (!af.getExcepcions().teExcepcions(4)){
											request.setAttribute("JspForm", jf);
											nextPage = "/jsp/"+pageNext+".jsp";
										}
									} else {
										af.novaExcepcio(new FormFacesExcepcio("JspForm "+pageNext+" no creada", 5));
										printErrors(af);
									}
								} else {
									af.novaExcepcio(new FormFacesExcepcio("Error al resoldre l pgina JSP de la Acci "+nameAction, 4));
									printErrors(af);
								}
							} catch (Exception e){
								af.novaExcepcio(new FormFacesExcepcio("Error al resoldre l pgina JSP de la Acci "+nameAction+" "+e.getMessage(), 4));
								printErrors(af);
							}
						} catch (Exception e){
							af.novaExcepcio(new FormFacesExcepcio("Error al executar Acci "+nameAction+": "+e.getMessage(), 4));
							printErrors(af);
						}
					}
				} else {
					printErrors(af);
				}
				request.setAttribute("excepcions", af.getExcepcions());
			}
		} catch (Exception e){
			System.out.println(e.getMessage());
		}
		return nextPage;
	}
	
	private void printErrors(ActionForm af){
		Excepcions ex = af.getExcepcions();
		for (Iterator<FormFacesExcepcio> it=ex.getItExcepcions(); it.hasNext();){
			FormFacesExcepcio cl = it.next();
			System.out.println(cl.getGravetat()+" - "+cl.getMessage());
		}
	}

}
