package formFaces.tags;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspWriter;
import javax.servlet.ServletRequest;

import java.io.IOException;

import formFaces.action.JspForm;

public class CampClasseTag extends TagSupport {
	
	private String nomClasse;
	private String nomCamp;
	
		public int doStartTag() {
			ServletRequest request = pageContext.getRequest();
			JspForm jf = (JspForm)request.getAttribute("JspForm");
			if (jf != null) {
				try {
					JspWriter out = pageContext.getOut();
					out.print(jf.getClasse(nomClasse).getValor(nomCamp));
				} catch(IOException ioe) {
					System.out.println("Error cercant el valor del camp "+nomCamp+" de la classe "+nomClasse+": " + ioe);
				}
				return(EVAL_BODY_INCLUDE);
			} else {
				System.out.println("Error construint CampClasseTag JspForm no existeix a request");
				return(SKIP_BODY);
			}
		}
		
		public void setNomClasse(String nom) {
			this.nomClasse = nom;
		}		


		public void setNomCamp(String nom) {
			this.nomCamp = nom;
		}		


		public int doEndTag() {
			return(EVAL_PAGE); // Continue with rest of JSP page
		}
		
}
